import { reactive } from "vue";
import { useInjector, useRequest } from "vue-vulcan";
import { useAuthData } from "./useAuthData";

interface UserData {
  id: string;
  company_id: string;
  nickname: string;
  avatar: string;
  permission: string;
  token: string;
}

export function useLogin() {
	const loginData = reactive({
		login_id: '',
		login_password: ''
	})
	const [, request] = useRequest<UserData>('/loginIn', { auto: false });
	const { setAuth } = useInjector(useAuthData);

	const submitLogin = () => {
		return request(loginData)
			.then( data => setAuth(data) )
	}


	return {
		loginData,
		submitLogin
	}

}