import { useAuthData } from "any-hooks/auth/useAuthData";
import { useAgoraClient } from "any-hooks/common/useAgoraClient";
import { computed, watch } from "vue";
import { useInjector } from "vue-vulcan";
import { useChannelStore } from "./useChannelStore";


/** 会议中心功能, 该功能在呼叫功能生效后使用，通过调用agoraSDK实现多人视频会议、语音会议的功能  */
export function useMeetingCenter() {
  const { currentChannel }  = useInjector(useChannelStore);
  const { authData }        = useInjector(useAuthData)
  const {joinChannelWithVideo, streamList, localPushurl} = useAgoraClient();

  // const meetingMembers = computed()

  watch(currentChannel, channel => {
    joinChannelWithVideo(
      channel.agora_token,
      channel.channel_id,
      authData.value.id
    )
  })

  return {
    streamList,
    localPushurl
  }
}