type AgoraEventType = 'stream-added' | 'stream-removed' | 'update-url"'

export interface AgoraSdkClient {
  init: (appid: string, success?: any, err?: any) => void;
  join: (token: string, cid: string, uid: string, success?: any, err?: any) => void;
  rejoin: (cb: any) => void;
  publish(onSuccess: (url: string) => void, onFailure?: (err: { code: number; reason: string }) => void): void;
  on(event: "error", callback: (evt: { code: number; reason: string }) => void): void;
  on(event: AgoraEventType, callback: (evt: { uid: string, url?: string }) => void): void;
  off: (cb: any) => void;
  subscribe(uid: string, onSuccess: (url: string) => void, onFailure?: (err: any) => void): void
  leave: (cb: any) => void;
  destory: (cb: any) => void;
}

export interface AgoraAppStore {
  appid: string;
  client: AgoraSdkClient;
}
