
export interface CustomeSocket<S> {
  connect?: (url: string) => void;
  send: (data: S) => void;
  close: () => void;
  addEventListener<K extends keyof WebSocketEventMap>(type: K, listener: (this: WebSocket, ev: WebSocketEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
}

export interface SocketSettings {
  retryLimit?: number;
  heartData?: any;
  heartInterval?: number;  
}

export type ConnectStatus = 'ready' | 'opening' | 'onerror' | 'closed' | 'reconnect';

export type AnyRemoteMainFlag = 'Heart' | 'Login' | 'Broadcast' | 'Home' | 'CallOffer' | 'CallAnswer';
export type AnyRemoteSubFlag = 'Request' | 'Busying' | 'Connect' | 'Hangup';

export interface AnyRemoteSocketMessage {
  fromID?: string;
  fromName?: string;
  avatar?: string;
  msgMainFlag: AnyRemoteMainFlag;
  msgSubFlag?: AnyRemoteSubFlag;
  msgData?: any;
  toID: string;
  toName?: string;
  channelID?: string;
}