import { useAuthData } from "../../../any-hooks/auth/useAuthData";
import { HttpIntercept, HttpResponse, HTTP_INTERCEPT, RequestOptions, useInjector } from "vue-vulcan";

export function useHttpIntercept(): HttpIntercept {

	const { authData } = useInjector(useAuthData);
	
	const requestIntercept = (reqs: RequestOptions) => {
		console.log(reqs)
		const token = authData.value?.token || '';		
		reqs.data.token = token;
		return new Promise( (resolve, reject) => {			
			if(token || reqs.path.includes('login')) {
				resolve(reqs)
			}	else {
				reject(`the http request ${reqs.path} need token`)
			}			
		})
	}

	const responseIntercept = (res: HttpResponse) => {
		return new Promise( resolve => {			
			resolve(res.data.data)
		})
	}
	
	return {
		requestIntercept,
		responseIntercept
	}
}

useHttpIntercept.token = HTTP_INTERCEPT;